Bug 3701 - rsync_xal_set: lsetxattr system.posix_acl_default failed: Permission denied
rsync_xal_set: lsetxattr system.posix_acl_default failed: Permission denied
Status: RESOLVED FIXED
Product: rsync
Classification: Unclassified
Component: core
2.6.9
x86 Linux
: P3 major
: ---
Assigned To: Wayne Davison
Rsync QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2006-04-19 15:48 UTC by Sven Strickroth
Modified: 2008-09-24 20:15 UTC (History)
1 user (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Sven Strickroth 2006-04-19 15:48:55 UTC
[root@fileserver /home/lsoftware/someprog/Muster]# mount
...
/dev/hda4 on /home type ext3 (rw,nodev,acl,user_xattr,usrquota)
...

[root@fileserver /home/lsoftware/someprog/Muster]# getfattr -d HLPTEXT.TXT
[root@fileserver /home/lsoftware/someprog/Muster]# getfacl HLPTEXT.TXT
# file: HLPTEXT.TXT
# owner: root
# group: users
user::rwx
user:hush:rwx
group::---
group:praes:r-x
mask::rwx
other::---

[root@backup /]# /usr/bin/rsync -avzRX --acls --delete-after --rsh="ssh -l bckup -i /root/backup.key" backup@fileserver::all/home/lsoftware backup/ >/dev/null
home/lsoftware/someprog/Muster/FLOSKEL.MST: rsync_xal_set: lsetxattr system.posix_acl_default failed: Permission denied
home/lsoftware/someprog/Muster/HLPTEXT.TXT: rsync_xal_set: lsetxattr system.posix_acl_default failed: Permission denied
home/lsoftware/someprog/Muster/LAYOUT.MST: rsync_xal_set: lsetxattr system.posix_acl_default failed: Permission denied
home/lsoftware/someprog/Muster/MUSTER.MS1: rsync_xal_set: lsetxattr system.posix_acl_default failed: Permission denied
...

[root@backup /]# mount
...
/dev/hda3 on /backup type ext3 (rw,acl,user_xattr)
...

If I run without "-X" I get no error-messages... - But then I can't backup extendet-attributes.
Comment 1 Matt McCutchen 2006-04-19 20:18:56 UTC
The trouble is that rsync is trying to set a default ACL on a file, which doesn't make sense.  (Why the ACL designers chose "Permission denied" as the error message I can't say; I complained on their mailing list.)

Rsync's extended attribute support is known to be a little spotty (bug 2793).  Probably rsync noticed a directory that had system.posix_acl_default and didn't properly forget the attribute when it moved to the next file.  Perhaps someone could read xattrs.c and find the specific problem.
Comment 2 Wayne Davison 2006-10-25 21:06:34 UTC
If you have a chance, please test newest version from CVS (also available in the latest "nightly" tar file on the download page of the website).  I have made some bug fixes that fixed some memory problems.
Comment 3 Wayne Davison 2006-11-10 21:39:17 UTC
The latest patch also skips system.* xattrs, since they are set via non-xattr calls.
Comment 4 Bill McGonigle 2008-09-24 20:15:23 UTC
Did this make it into version 3?  I get, e.g.:

  rsync_xal_set: lsetxattr("Volumes/Local/sw/src/fink.build/root-netpbm-9.25-15/sw/lib/libpbm.dylib","user.com.apple.FinderInfo") failed: Operation not permitted (1)

with version:

  rsync  version 3.0.3  protocol version 30

and the command:

  /usr/local/bin/rsync3 -ax --archive --delete --relative --hard-links --sparse --delete-excluded --numeric-ids --ignore-errors --acls --xattrs --rsync-path='/usr/local/sbin/rsync_wrapper.sh' --rsh='/usr/bin/ssh -c blowfish -i /home/backup/.ssh/id_rsa -x' --link-dest=/mnt/backup/snapshots/mac/daily.1/laptop/ backup@laptop:/Volumes/Local /mnt/backup/snapshots/mac/daily.0/laptop/